diff --git a/config/meson.build b/config/meson.build
index 3a36d9dd4c..860dfd2e67 100644
--- a/config/meson.build
+++ b/config/meson.build
@@ -254,7 +254,7 @@ dpdk_conf.set('RTE_COMPILE_TIME_CPUFLAGS', ','.join(compile_time_cpuflags))
 # set the install path for the drivers
 dpdk_conf.set_quoted('RTE_EAL_PMD_PATH', eal_pmd_path)
 
-install_headers(['rte_config.h', 'rte_compatibility_defines.h'],
+install_headers(['rte_config.h'],
 		subdir: get_option('include_subdir_arch'))
 
 # enable VFIO only if it is linux OS
diff --git a/config/rte_compatibility_defines.h b/config/rte_compatibility_defines.h
deleted file mode 100644
index 47600052b6..0000000000
--- a/config/rte_compatibility_defines.h
+++ /dev/null
@@ -1,129 +0,0 @@
-/* SPDX-License-Identifier: BSD-3-Clause
- * Copyright(c) 2017 Intel Corporation
- */
-
-#ifndef _RTE_CONFIG_H_
-#error "This file should only be included via rte_config.h"
-#endif
-
-/*
- * NOTE: these defines are for compatibility only and will be removed in a
- * future DPDK release.
- */
-
-#ifdef RTE_LIBRTE_BITRATESTATS
-#define RTE_LIBRTE_BITRATE
-#endif
-
-#ifdef RTE_LIBRTE_LATENCYSTATS
-#define RTE_LIBRTE_LATENCY_STATS
-#endif
-
-#ifdef RTE_LIBRTE_DPAAX_COMMON
-#define RTE_LIBRTE_COMMON_DPAAX
-#endif
-
-#ifdef RTE_LIBRTE_VMBUS_BUS
-#define RTE_LIBRTE_VMBUS
-#endif
-
-#ifdef RTE_LIBRTE_BUCKET_MEMPOOL
-#define RTE_DRIVER_MEMPOOL_BUCKET
-#endif
-
-#ifdef RTE_LIBRTE_RING_MEMPOOL
-#define RTE_DRIVER_MEMPOOL_RING
-#endif
-
-#ifdef RTE_LIBRTE_STACK_MEMPOOL
-#define RTE_DRIVER_MEMPOOL_STACK
-#endif
-
-#ifdef RTE_LIBRTE_AF_PACKET_PMD
-#define RTE_LIBRTE_PMD_AF_PACKET
-#endif
-
-#ifdef RTE_LIBRTE_AF_XDP_PMD
-#define RTE_LIBRTE_PMD_AF_XDP
-#endif
-
-#ifdef RTE_LIBRTE_BOND_PMD
-#define RTE_LIBRTE_PMD_BOND
-#endif
-
-#ifdef RTE_LIBRTE_E1000_PMD
-#define RTE_LIBRTE_EM_PMD
-#endif
-
-#ifdef RTE_LIBRTE_E1000_PMD
-#define RTE_LIBRTE_IGB_PMD
-#endif
-
-#ifdef RTE_LIBRTE_FAILSAFE_PMD
-#define RTE_LIBRTE_PMD_FAILSAFE
-#endif
-
-#ifdef RTE_LIBRTE_KNI_PMD
-#define RTE_LIBRTE_PMD_KNI
-#endif
-
-#ifdef RTE_LIBRTE_LIQUIDIO_PMD
-#define RTE_LIBRTE_LIO_PMD
-#endif
-
-#ifdef RTE_LIBRTE_MEMIF_PMD
-#define RTE_LIBRTE_PMD_MEMIF
-#endif
-
-#ifdef RTE_LIBRTE_NULL_PMD
-#define RTE_LIBRTE_PMD_NULL
-#endif
-
-#ifdef RTE_LIBRTE_PCAP_PMD
-#define RTE_LIBRTE_PMD_PCAP
-#endif
-
-#ifdef RTE_LIBRTE_RING_PMD
-#define RTE_LIBRTE_PMD_RING
-#endif
-
-#ifdef RTE_LIBRTE_SFC_PMD
-#define RTE_LIBRTE_SFC_EFX_PMD
-#endif
-
-#ifdef RTE_LIBRTE_SOFTNIC_PMD
-#define RTE_LIBRTE_PMD_SOFTNIC
-#endif
-
-#ifdef RTE_LIBRTE_SZEDATA2_PMD
-#define RTE_LIBRTE_PMD_SZEDATA2
-#endif
-
-#ifdef RTE_LIBRTE_TAP_PMD
-#define RTE_LIBRTE_PMD_TAP
-#endif
-
-#ifdef RTE_LIBRTE_THUNDERX_PMD
-#define RTE_LIBRTE_THUNDERX_NICVF_PMD
-#endif
-
-#ifdef RTE_LIBRTE_VHOST_PMD
-#define RTE_LIBRTE_PMD_VHOST
-#endif
-
-#ifdef RTE_LIBRTE_PMD_ARMV8
-#define RTE_LIBRTE_PMD_ARMV8_CRYPTO
-#endif
-
-#ifdef RTE_LIBRTE_PMD_MVSAM
-#define RTE_LIBRTE_PMD_MVSAM_CRYPTO
-#endif
-
-#ifdef RTE_LIBRTE_PMD_OCTEONTX_COMPRESS
-#define RTE_LIBRTE_PMD_OCTEONTX_ZIPVF
-#endif
-
-#ifdef RTE_LIBRTE_PMD_OCTEONTX_EVENTDEV
-#define RTE_LIBRTE_PMD_OCTEONTX_SSOVF
-#endif
-
diff --git a/config/rte_config.h b/config/rte_config.h
index cacc1837cf..0bae630fd9 100644
--- a/config/rte_config.h
+++ b/config/rte_config.h
@@ -13,7 +13,6 @@
 #define _RTE_CONFIG_H_
 
 #include <rte_build_config.h>
-#include <rte_compatibility_defines.h>
 
 /* legacy defines */
 #ifdef RTE_EXEC_ENV_LINUX
diff --git a/drivers/baseband/meson.build b/drivers/baseband/meson.build
index 7e1b64ffdd..4102769827 100644
--- a/drivers/baseband/meson.build
+++ b/drivers/baseband/meson.build
@@ -6,5 +6,3 @@ if is_windows
 endif
 
 drivers = ['null', 'turbo_sw', 'fpga_lte_fec', 'fpga_5gnr_fec']
-
-config_flag_fmt = 'RTE_LIBRTE_PMD_BBDEV_@0@'
diff --git a/drivers/bus/meson.build b/drivers/bus/meson.build
index bd73efd187..2e7727af08 100644
--- a/drivers/bus/meson.build
+++ b/drivers/bus/meson.build
@@ -3,4 +3,3 @@
 
 drivers = ['dpaa', 'fslmc', 'ifpga', 'pci', 'vdev', 'vmbus']
 std_deps = ['eal']
-config_flag_fmt = 'RTE_LIBRTE_@0@_BUS'
diff --git a/drivers/common/meson.build b/drivers/common/meson.build
index d78882f05e..ba6325adf3 100644
--- a/drivers/common/meson.build
+++ b/drivers/common/meson.build
@@ -7,4 +7,3 @@ endif
 
 std_deps = ['eal']
 drivers = ['cpt', 'dpaax', 'iavf', 'mvep', 'octeontx', 'octeontx2', 'sfc_efx']
-config_flag_fmt = 'RTE_LIBRTE_@0@_COMMON'
diff --git a/drivers/compress/meson.build b/drivers/compress/meson.build
index 33f5e33dde..cd96def086 100644
--- a/drivers/compress/meson.build
+++ b/drivers/compress/meson.build
@@ -8,4 +8,3 @@ endif
 drivers = ['isal', 'octeontx', 'zlib']
 
 std_deps = ['compressdev'] # compressdev pulls in all other needed deps
-config_flag_fmt = 'RTE_LIBRTE_PMD_@0@'
diff --git a/drivers/compress/octeontx/meson.build b/drivers/compress/octeontx/meson.build
index 2d71b4da21..e1b7bed422 100644
--- a/drivers/compress/octeontx/meson.build
+++ b/drivers/compress/octeontx/meson.build
@@ -1,7 +1,6 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2018 Cavium, Inc
 
-fmt_name = 'octeontx_compress'
 sources = files('otx_zip.c', 'otx_zip_pmd.c')
 includes += include_directories('include')
 deps += ['mempool_octeontx', 'bus_pci']
diff --git a/drivers/crypto/meson.build b/drivers/crypto/meson.build
index fa5c7ef3a5..8a82be9b05 100644
--- a/drivers/crypto/meson.build
+++ b/drivers/crypto/meson.build
@@ -25,4 +25,3 @@ drivers = ['aesni_gcm',
 	   'zuc']
 
 std_deps = ['cryptodev'] # cryptodev pulls in all other needed deps
-config_flag_fmt = 'RTE_LIBRTE_PMD_@0@'
diff --git a/drivers/crypto/null/meson.build b/drivers/crypto/null/meson.build
index 421414916c..1f7d644de1 100644
--- a/drivers/crypto/null/meson.build
+++ b/drivers/crypto/null/meson.build
@@ -2,5 +2,4 @@
 # Copyright(c) 2017 Intel Corporation
 
 deps += 'bus_vdev'
-fmt_name = 'null_crypto'
 sources = files('null_crypto_pmd.c', 'null_crypto_pmd_ops.c')
diff --git a/drivers/crypto/octeontx/meson.build b/drivers/crypto/octeontx/meson.build
index d6939720d8..ef3c003945 100644
--- a/drivers/crypto/octeontx/meson.build
+++ b/drivers/crypto/octeontx/meson.build
@@ -7,7 +7,6 @@ endif
 
 deps += ['bus_pci']
 deps += ['common_cpt']
-fmt_name = 'octeontx_crypto'
 
 sources = files('otx_cryptodev.c',
 		'otx_cryptodev_capabilities.c',
diff --git a/drivers/crypto/octeontx2/meson.build b/drivers/crypto/octeontx2/meson.build
index bf502e247d..87296f2a2a 100644
--- a/drivers/crypto/octeontx2/meson.build
+++ b/drivers/crypto/octeontx2/meson.build
@@ -11,7 +11,6 @@ deps += ['common_cpt']
 deps += ['common_octeontx2']
 deps += ['ethdev']
 deps += ['security']
-fmt_name = 'octeontx2_crypto'
 
 sources = files('otx2_cryptodev.c',
 		'otx2_cryptodev_capabilities.c',
diff --git a/drivers/crypto/scheduler/meson.build b/drivers/crypto/scheduler/meson.build
index 2209c50232..b67d9306e0 100644
--- a/drivers/crypto/scheduler/meson.build
+++ b/drivers/crypto/scheduler/meson.build
@@ -2,7 +2,6 @@
 # Copyright(c) 2018 Luca Boccassi <bluca@debian.org>
 
 deps += ['bus_vdev', 'reorder']
-fmt_name = 'crypto_scheduler'
 sources = files(
 	'rte_cryptodev_scheduler.c',
 	'scheduler_failover.c',
diff --git a/drivers/crypto/virtio/meson.build b/drivers/crypto/virtio/meson.build
index 6cea782deb..20e9e9551e 100644
--- a/drivers/crypto/virtio/meson.build
+++ b/drivers/crypto/virtio/meson.build
@@ -3,6 +3,5 @@
 
 includes += include_directories('../../../lib/librte_vhost')
 deps += 'bus_pci'
-fmt_name = 'virtio_crypto'
 sources = files('virtio_cryptodev.c', 'virtio_pci.c',
 		'virtio_rxtx.c', 'virtqueue.c')
diff --git a/drivers/event/meson.build b/drivers/event/meson.build
index a7dac99de2..a2b6cedaa8 100644
--- a/drivers/event/meson.build
+++ b/drivers/event/meson.build
@@ -11,4 +11,3 @@ if not (toolchain == 'gcc' and cc.version().version_compare('<4.8.6') and
 	drivers += 'octeontx'
 endif
 std_deps = ['eventdev', 'kvargs']
-config_flag_fmt = 'RTE_LIBRTE_PMD_@0@_EVENTDEV'
diff --git a/drivers/mempool/meson.build b/drivers/mempool/meson.build
index 036647149e..16b9693505 100644
--- a/drivers/mempool/meson.build
+++ b/drivers/mempool/meson.build
@@ -7,4 +7,3 @@ endif
 
 drivers = ['bucket', 'dpaa', 'dpaa2', 'octeontx', 'octeontx2', 'ring', 'stack']
 std_deps = ['mempool']
-config_flag_fmt = 'RTE_LIBRTE_@0@_MEMPOOL'
diff --git a/drivers/meson.build b/drivers/meson.build
index a5a6fed06e..ad3fecb86f 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -32,7 +32,6 @@ endif
 foreach subpath:subdirs
 	drivers = []
 	std_deps = []
-	config_flag_fmt = '' # format string used to set the value in dpdk_conf
 
 	# subpath can be either "class" or "class/driver"
 	if subpath.contains('/')
@@ -58,7 +57,6 @@ foreach subpath:subdirs
 		build = true # set to false to disable, e.g. missing deps
 		reason = '<unknown reason>' # set if build == false to explain
 		name = drv
-		fmt_name = ''
 		sources = []
 		objs = []
 		cflags = default_cflags
@@ -113,27 +111,6 @@ foreach subpath:subdirs
 			lib_name = '_'.join(['rte', class, name])
 			dpdk_conf.set(lib_name.to_upper(), 1)
 
-			if fmt_name == ''
-				fmt_name = name
-			endif
-
-			dpdk_conf.set(config_flag_fmt.format(fmt_name.to_upper()),1) #old-style macro
-			# for driver compatibility, since we changed the
-			# default to match that of make. Remove in future release
-			# after following deprecation process
-			if config_flag_fmt.contains('_PMD_@0@') and (class == 'crypto'
-					or class == 'compress'
-					or class == 'event')
-				alt_flag_fmt = '_@0@_PMD'.join(
-						config_flag_fmt.split('_PMD_@0@'))
-				if config_flag_fmt.contains('EVENTDEV')
-					alt_flag_fmt = '_@0@_EVENTDEV_PMD'.join(
-						config_flag_fmt.split('_PMD_@0@_EVENTDEV'))
-				endif
-				dpdk_conf.set(alt_flag_fmt.format(
-						fmt_name.to_upper()), 1)
-			endif
-
 			dpdk_extra_ldflags += pkgconfig_extra_libs
 
 			# generate pmdinfo sources by building a temporary
diff --git a/drivers/net/meson.build b/drivers/net/meson.build
index 4e4c2c976a..0612dc9c59 100644
--- a/drivers/net/meson.build
+++ b/drivers/net/meson.build
@@ -58,4 +58,3 @@ drivers = ['af_packet',
 std_deps = ['ethdev', 'kvargs'] # 'ethdev' also pulls in mbuf, net, eal etc
 std_deps += ['bus_pci']         # very many PMDs depend on PCI, so make std
 std_deps += ['bus_vdev']        # same with vdev bus
-config_flag_fmt = 'RTE_LIBRTE_@0@_PMD'
diff --git a/drivers/raw/meson.build b/drivers/raw/meson.build
index d8d6cf5824..8c3a036dfd 100644
--- a/drivers/raw/meson.build
+++ b/drivers/raw/meson.build
@@ -11,4 +11,3 @@ drivers = ['dpaa2_cmdif', 'dpaa2_qdma',
 	'octeontx2_ep',
 	'skeleton']
 std_deps = ['rawdev']
-config_flag_fmt = 'RTE_LIBRTE_PMD_@0@_RAWDEV'
diff --git a/drivers/regex/meson.build b/drivers/regex/meson.build
index f171e9fdf0..8ce5bafe9e 100644
--- a/drivers/regex/meson.build
+++ b/drivers/regex/meson.build
@@ -3,4 +3,3 @@
 
 drivers = ['mlx5']
 std_deps = ['ethdev', 'kvargs'] # 'ethdev' also pulls in mbuf, net, eal etc
-config_flag_fmt = 'RTE_LIBRTE_@0@_PMD'
diff --git a/drivers/regex/mlx5/meson.build b/drivers/regex/mlx5/meson.build
index d7cb2c5721..87e9611812 100644
--- a/drivers/regex/mlx5/meson.build
+++ b/drivers/regex/mlx5/meson.build
@@ -7,7 +7,6 @@ if not is_linux
 	subdir_done()
 endif
 
-fmt_name = 'mlx5_regex'
 deps += ['common_mlx5', 'eal', 'regexdev']
 sources = files(
 	'mlx5_regex.c',
diff --git a/drivers/vdpa/meson.build b/drivers/vdpa/meson.build
index b346e43086..4929be4c03 100644
--- a/drivers/vdpa/meson.build
+++ b/drivers/vdpa/meson.build
@@ -9,4 +9,3 @@ drivers = ['ifc',
 	   'mlx5',]
 std_deps = ['bus_pci', 'kvargs']
 std_deps += ['vhost']
-config_flag_fmt = 'RTE_LIBRTE_@0@_PMD'
diff --git a/drivers/vdpa/mlx5/meson.build b/drivers/vdpa/mlx5/meson.build
index 254a8ec14b..a83ca86b3f 100644
--- a/drivers/vdpa/mlx5/meson.build
+++ b/drivers/vdpa/mlx5/meson.build
@@ -7,7 +7,6 @@ if not is_linux
 	subdir_done()
 endif
 
-fmt_name = 'mlx5_vdpa'
 deps += ['hash', 'common_mlx5', 'vhost', 'pci', 'eal', 'sched']
 sources = files(
 	'mlx5_vdpa.c',
diff --git a/lib/meson.build b/lib/meson.build
index 1d40cb13a9..faeb22695c 100644
--- a/lib/meson.build
+++ b/lib/meson.build
@@ -97,8 +97,7 @@ foreach l:libraries
 		set_variable(name.underscorify() + '_disable_reason', reason)
 	else
 		enabled_libs += name
-		dpdk_conf.set('RTE_LIBRTE_' + name.to_upper(), 1) #old macro
-		dpdk_conf.set('RTE_LIB_' + name.to_upper(), 1) # new macro
+		dpdk_conf.set('RTE_LIB_' + name.to_upper(), 1)
 		install_headers(headers)
 
 		libname = 'rte_' + name